/*
 *  This file is part of M-Index library: https://bitbucket.org/disalab/m-index
 *
 *  M-Index library is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  M-Index library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with M-Index library.  If not, see <http://www.gnu.org/licenses/>.
 */
package messif.appl;

import junit.framework.TestCase;

/**
 * @author david
 */
public class MIndexCFTest extends TestCase {

    private final static String DATA_FILE = "src/test/resources/dataobjects.json";
    private final static String QUERY_FILE = "src/test/resources/dataobjects.json";
    private final static String CF_FILE_MINDEX = "src/test/resources/mindex.cf";
    private final static String CF_FILE_UPDATE = "src/test/resources/update-data.cf";
    private final static String CF_FILE_OPERATIONS = "src/test/resources/search-ops.cf";



    public MIndexCFTest(String testName) {
        super(testName);
    }

    Application application;

    @Override
    protected void setUp() throws Exception {
        super.setUp();
        this.application = new Application();
    }

    public void testBuildMIndex() {
        this.application.controlFile(System.out, "configFile", CF_FILE_MINDEX, "buildMIndex");
        this.application.controlFile(System.out, "configFile", CF_FILE_UPDATE, "datafile=" + DATA_FILE, "insertData");
        System.out.flush();
        System.err.flush();
        this.application.algorithmInfoAll(System.out);
        this.application.controlFile(System.out, "configFile", CF_FILE_MINDEX, "serialize");
        this.application.algorithmStopAll(System.out);
    }

    public void testDeserializeQuery() {
        this.application.controlFile(System.out, "configFile", CF_FILE_MINDEX, "deserializeMIndex");
        this.application.controlFile(System.out,
                "configFile",
                CF_FILE_OPERATIONS,
                "k=5",
                "candidateSize=8",
                "approxPercentile=0.5",
                "distmeasure=WeightedSumDistCalculatorTight",
                "queryfile=" + QUERY_FILE,
                "testRunOp");
        this.application.controlFile(System.out, "configFile", CF_FILE_UPDATE, "datafile=" + DATA_FILE, "insertData");
        this.application.algorithmStopAll(System.out);
    }


}
